#include <QCoreApplication>
//Подключаем используемые в коде классы
#include <QStringList>
#include <QProcess>
#include <QDebug>

int main(int argc, char *argv[])
{
    //В консольном приложении объект приложения имеет класс QCoreApplication
    QCoreApplication a(argc, argv);

    //Проверяем, что есть хотя бы один параметр командной строки и первый параметр не содержит имени
    //самого приложения (чтобы избежать рекурсивного вызова программы)
    if ((a.arguments().count() < 2) || (a.arguments().at(1).contains("ReExecuter", Qt::CaseInsensitive))){
        qDebug() << "Wrong arguments";
        return 0;
    }
    //Копируем параметры командной строки (кроме первого) в отдельный объект
    QStringList params = a.arguments();
    params.removeFirst();

    //Создаем объект процесса
    QProcess process(&a);
    //Бесконечный цикл перезапуска процесса
    while (true){
        //Если процесс не запущен
        if(process.state() == QProcess::NotRunning){
            //запускаем процесс с параметрами
            process.start(params.join(' '));
            //Если запустить не удалось, выводим ошибку и выходим из программы
            if(process.state() == QProcess::NotRunning){
                qDebug() << "Cannot execute " << params.first();
                return 0;
            }
        }
        //блокирующий метод ожидания остановки процесса
        process.waitForFinished();
    }
}
